<?php

namespace App\Providers;

use Illuminate\Support\ServiceProvider;
use Illuminate\Pagination\Paginator;
use Illuminate\Support\Facades\Auth;
use View;
use Blade;

class AppServiceProvider extends ServiceProvider
{
    /**
     * Register any application services.
     */
    public function register(): void
    {
        //
    }

    /**
     * Bootstrap any application services.
     */
    public function boot(): void
    {
        Paginator::useBootstrap();
        View::composer('*', function($view){

            $sum = 0;
            $checkseesion = session()->get('cart');
            $view->with('cartItems', session()->get('cart'));
            $view->with('checkseesion', $checkseesion);
            if (!empty($checkseesion) || null) {
                foreach ($checkseesion as $item) {
                $result = (float)$item['invoice_quantity'] * (float)$item['invoice_unit_price'];
                $sum+=$result;
                }
                $view->with('totalCart', $sum);
            }



            $items = array(
                '1' => "Pepperoni",
                '2' => "Chicken Fillet",
                '3' => "Brisket",
                '4' => "Ham",
                '5' => "Prepared Beef",
                '6' => "Mortadella",
                '7' => "Tuna"
            );

            $view->with('constituents', $items);


            Blade::directive('convert', function ($money) {
                return "<?php echo number_format($money, 2); ?>";
            });

        });
    
    }
}
